   MEMBER
!**********************************************************************************************************************
! xPictureBrowse Class v2.4
! Copyright 2001-2010, SealSoft Company
!**********************************************************************************************************************

  OMIT('***', _C55_)
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)
  ***

   MAP
     MODULE('Windows API')
       GetLogicalDrives(), LONG, PASCAL, NAME('GetLogicalDrives')
       GetDriveType(*CSTRING),UNSIGNED,RAW,PASCAL,NAME('GetDriveTypeA')
       FnSplit(*cstring,*cstring,*cstring,*cstring,*cstring),short,raw,name('_fnsplit')
     END
   END

   INCLUDE('equates.clw'),ONCE
   INCLUDE('keycodes.clw'),ONCE
   INCLUDE('xpbrowse.inc'),ONCE
   INCLUDE('xpbrowse.trn'),ONCE

FILE_BEGIN              ULONG(0)
DRIVE_RAMDISK           EQUATE(1)
DRIVE_REMOVABLE         EQUATE(2)
DRIVE_FIXED             EQUATE(3)
DRIVE_REMOTE            EQUATE(4)
DRIVE_CDROM             EQUATE(5)

Title                   EQUATE('xPictureBrowse')
Version                 EQUATE('v2.4')

!**********************************************************************************************************************
xPBrowseClass.Construct   PROCEDURE
  CODE
  SELF.AllFiles   &= NEW AllFilesQ
  SELF.SelFiles   &= NEW SelFilesQ
  SELF.Drivers    &= NEW DriversQ
  SELF.StoredDir  &= NEW StoredDirQ
  SELF.Resizer    &= NEW WindowResizeClass
  SELF.ImageOne   &= NEW xPViewClass
  SELF.Trn        &= NEW TranslatorClass
  SELF.Popup      &= NEW PopupClass
!**********************************************************************************************************************
xPBrowseClass.Destruct    PROCEDURE
  CODE
  IF ~SELF.Trn &= NULL
    SELF.Trn.Kill
    DISPOSE(SELF.Trn)
  END
  DISPOSE(SELF.Popup)
  CLEAR(SELF.AllFiles)
  CLEAR(SELF.SelFiles)
  CLEAR(SELF.Drivers)
  CLEAR(SELF.StoredDir)
  FREE(SELF.AllFiles)
  FREE(SELF.SelFiles)
  FREE(SELF.Drivers)
  FREE(SELF.StoredDir)
  DISPOSE(SELF.Resizer)
  DISPOSE(SELF.AllFiles)
  DISPOSE(SELF.SelFiles)
  DISPOSE(SELF.Drivers)
  DISPOSE(SELF.StoredDir)
  DISPOSE(SELF.ImageOne)
!**********************************************************************************************************************
xPBrowseClass.Init        PROCEDURE(STRING IniFileName)
  CODE
  SELF.IniFileName   = IniFileName
  SELF.Trn.Init
  SELF.Trn.AddTranslation(XPBTRN)
  SELF.CaptionName   = CLIP(SELF.Trn.TranslateString(Title)) & ' ' & Version
  SELF.PMode         = 1
  SELF.ThumbnailMode = 1
  SELF.SortMode      = 1

  SELF.Popup.Init
  SELF.Popup.SetTranslator(SELF.Trn)
  SELF.Popup.AddItem('Set filter','filter')
  SELF.Popup.AddItem('Filter enabled','filterenabled')
  SELF.Popup.AddItem('-','separator1')
  SELF.Popup.AddItem('Sort by Default','item1')
  SELF.Popup.AddItem('Sort by FileName','item2')
  SELF.Popup.AddItem('Sort by Size','item3')
  SELF.Popup.AddItem('Sort by DateTime','item4')
!**********************************************************************************************************************
xPBrowseClass.Kill        PROCEDURE
  CODE
!**********************************************************************************************************************
xPBrowseClass.BrowsePictureDir  PROCEDURE(*STRING PictureFile, <STRING FilterString>, <STRING StartPath>, <*BYTE ReturnState>)
Recs                            LONG
LP                              LONG
OldFile                         STRING(256)
OnlyGraphics                    BYTE(1)
PicWidth                        LONG
PicHeight                       LONG
SAV:Pointer                     STRING(100)
Res:Mode                        BYTE
LOC:PictureFile                 STRING(255)
LOC:StartPath                   STRING(255)
LOC:ShowPicture                 BYTE(FALSE)
LOC:ShowPictureFile             STRING(255)
LOC:ShowTime                    LONG

Window WINDOW('xBrowse picture directory'),AT(,,344,156),FONT('MS Sans Serif',8,,),CENTER,IMM,ALRT(F4Key), |
         ALRT(F5Key),TIMER(1),SYSTEM,GRAY,MAX,RESIZE
       STRING(@s255),AT(104,4,237,10),USE(SELF.CSTRING,,?CString)
       PANEL,AT(102,2,242,14),USE(?TopPanel),FULL,BEVEL(1,-1)
       PANEL,AT(0,22,344,134),USE(?BottomPanel),FULL,BEVEL(1,-1)
       BUTTON,AT(2,2,17,15),USE(?OkBtn),FLAT,TIP('Choose picture'),ICON('xpbok.ico')
       BUTTON,AT(20,2,17,15),USE(?CancelButton),FLAT,TIP('Cancel picture'),ICON('xpbcancel.ico')
       PANEL,AT(39,1,1,16),USE(?Separator1),BEVEL(-1)
       PANEL,AT(97,1,1,16),USE(?Separator2),BEVEL(-1)
       OPTION,AT(48,6,40,7),USE(SELF.PMode,,?PMode)
         RADIO,AT(42,2,17,15),USE(?PMode:Radio1),FLAT,TIP('Autosize picture'),ICON('xpba.ico'),VALUE('1')
         RADIO,AT(60,2,17,15),USE(?PMode:Radio2),FLAT,TIP('Centered picture'),ICON('xpbc.ico'),VALUE('2')
         RADIO,AT(78,2,17,15),USE(?PMode:Radio3),FLAT,TIP('Tiled picture'),ICON('xpbt.ico'),VALUE('3')
       END
       PANEL,AT(0,18,,1),USE(?SeparatorHor),FULL,BEVEL(-1)
       COMBO(@s20),AT(4,27,195,11),USE(?DrvCombo),VSCROLL,LEFT(2),COLOR(,COLOR:Black,095A888H),HLP('Select drive'), |
           MSG('Select drive'),TIP('Select drive'),FORMAT('13L(2)@s2@8L(2)@s100@'),DROP(10),FROM(SELF.Drivers)
       IMAGE,AT(205,31,126,110),USE(?Image),HIDE,CENTERED
       PANEL,AT(201,26,139,127),USE(?iPanel),BEVEL(-1,1)
       LIST,AT(4,41,195,110),USE(?FileList),HVSCROLL,COLOR(,COLOR:Black,095A888H),HLP('Select file'), |
           MSG('Select file'),TIP('Select file'),ALRT(MouseLeft2),ALRT(EnterKey),ALRT(BSKey),ALRT(LeftKey), |
           ALRT(MouseRight),FORMAT('71L(1)|MY~File~@s255@35R(1)|MY~Size~L@n10b@46L(1)|MY~Date~@D01b@93L(1)|MY~Time~@' &|
           'T04b@'),FROM(SELF.SelFiles)
     END

  CODE
  OPEN(Window)
  ?FileList{PROP:LineHeight} = 11
  ?DrvCombo{PROP:LineHeight} = 11
  SELF.Trn.TranslateWindow(Window)

  Window{PROP:Text} = SELF.CaptionName

  SELF.Filter   = FilterString
  IF CLIP(SELF.Filter) <> ''
    SELF.FilterEnabled = 1
  ELSE
    SELF.FilterEnabled = 0
  END
  SELF.FileList = ?FileList
  SELF.DrvCombo = ?DrvCombo
  SELF.OkBtn    = ?OkBtn
  SELF.Image    = ?Image
  SELF.Panel    = ?iPanel

  SELF.CSTRING       = ''
  SELF.FindPath      = ''
  SELF.FindFile      = ''

  SELF.ImageOne.Init(Window, ?Image, ?IPanel, 2)
  SELF.LoadINI

  IF CLIP(?FileList{PROP:Format}) <> CLIP(SELF.OFormat)
    SELF.OFormat = ?FileList{PROP:Format}
    PUTINI('Setup', 'OFormat', SELF.OFormat, SELF.INIFileName)
  ELSIF CLIP(SELF.LFormat) <> ''
    ?FileList{PROP:Format} = SELF.LFormat
  END

  SELF.Resizer.Init(AppStrategy:Spread,Resize:SetMinSize)
  SELF.Resizer.SetParentDefaults
  SELF.Resizer.SetStrategy(?OkBtn, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?CancelButton, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?Separator1, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?Separator2, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?PMode, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?PMode:Radio1, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?PMode:Radio2, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?PMode:Radio3, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?TopPanel, Resize:FixLeft+Resize:FixTop, Resize:ConstantRight+Resize:LockHeight)
  SELF.Resizer.SetStrategy(?CString, Resize:FixLeft+Resize:FixTop, Resize:ConstantRight+Resize:LockHeight)
  SELF.Resizer.SetStrategy(?SeparatorHor, Resize:FixLeft+Resize:FixTop, Resize:ConstantRight+Resize:LockHeight)
  SELF.Resizer.SetStrategy(?BottomPanel, Resize:FixRight+Resize:FixTop, Resize:ConstantRight+Resize:ConstantBottom)
  SELF.Resizer.SetStrategy(?DrvCombo, Resize:FixLeft+Resize:FixTop, Resize:LockSize)
  SELF.Resizer.SetStrategy(?FileList, Resize:FixLeft+Resize:FixTop, Resize:LockWidth+Resize:ConstantBottom)
  SELF.Resizer.SetStrategy(?IPanel, Resize:FixLeft+Resize:FixTop, Resize:ConstantRight+Resize:ConstantBottom)

  Window{PROP:XPos} = GETINI('xpbWin', 'XPos', Window{PROP:XPos}, SELF.INIFileName)
  Window{PROP:YPos} = GETINI('xpbWin', 'YPos', Window{PROP:YPos}, SELF.INIFileName)
  Window{PROP:Width} = GETINI('xpbWin', 'Width', Window{PROP:Width}, SELF.INIFileName)
  Window{PROP:Height} = GETINI('xpbWin', 'Height', Window{PROP:Height}, SELF.INIFileName)

  SELF.Resizer.Resize
  SELF.Resizer.Reset

  ACCEPT
    CASE ACCEPTED()
    OF ?PMode
      SELF.ImageOne.ShowPicture(SELF.ResultString, SELF.PMode)
      SELECT(SELF.FileList)
    OF ?OkBtn
      Res:Mode = BUTTON:Ok
      BREAK
    OF ?CancelButton
      Res:Mode = BUTTON:Cancel
      BREAK
    OF ?DrvCombo
      GET(SELF.Drivers,CHOICE(?DrvCombo))
      IF SELF.OldDrive <> SELF.Drivers.Disk
        SELF.FindPath = SELF.Drivers.Disk&'\'
        SELF.RefreshDirectory
        SELF.OldDrive = SELF.Drivers.Disk
      END
    END ! case accepted
!---------------------------
    CASE FIELD()
    OF ?FileList
      CASE EVENT()
      OF EVENT:PreAlertKey
        CASE KEYCODE()
        OF LeftKey
          PressKey(HomeKey)
        OF BSKey
          SAV:Pointer = POINTER(SELF.SelFiles)
          GET(SELF.SelFiles,1)
          IF CLIP(SELF.SelFiles.FileName) = '..'
            SELF.CSTRING = CLIP(SELF.FindPath)
            Recs = LEN(CLIP(SELF.CSTRING))
            LOOP E# = Recs-1 TO 1 BY -1
              IF SELF.FindPath[E#] = '\'
                SELF.FindPath = SUB(SELF.FindPath,1,E#)
                BREAK
              END
            END
            SELF.RefreshDirectory
          ELSE
            GET(SELF.SelFiles, SAV:Pointer)
          END
          SELF.RestoreLevel
        OF MouseLeft2
        OROF EnterKey
          GET(SELF.SelFiles, CHOICE(SELF.FileList))
          IF (CLIP(SELF.SelFiles.FileName) = '..') AND (SELF.SelFiles.Type = 1)
            SELF.CSTRING = CLIP(SELF.FindPath)
            Recs = LEN(CLIP(SELF.CSTRING))
            LOOP E# = Recs-1 TO 1 BY -1
              IF SELF.FindPath[E#] = '\'
                SELF.FindPath = SUB(SELF.FindPath,1,E#)
                BREAK
              END
            END
            SELF.RefreshDirectory
            SELF.RestoreLevel
          ELSIF SELF.SelFiles.Type = 2
            SELF.FindPath = CLIP(SELF.FindPath) & CLIP(SELF.SelFiles.FileName) & '\'
            SELF.StoreLevel(SELF.SelFiles.FileName)
            SELF.RefreshDirectory
          ELSIF SELF.SelFiles.Type = 3
            SELF.CSTRING = LOC:ShowPictureFile
            POST(EVENT:Accepted, ?OkBtn)
          END
        OF MouseRight
          SELF.Popup.SetItemCheck('filterenabled',SELF.FilterEnabled)
          SELF.Popup.SetItemCheck('item1',FALSE)
          SELF.Popup.SetItemCheck('item2',FALSE)
          SELF.Popup.SetItemCheck('item3',FALSE)
          SELF.Popup.SetItemCheck('item4',FALSE)
          EXECUTE SELF.SortMode
            SELF.Popup.SetItemCheck('item1',TRUE)
            SELF.Popup.SetItemCheck('item2',TRUE)
            SELF.Popup.SetItemCheck('item3',TRUE)
            SELF.Popup.SetItemCheck('item4',TRUE)
          END
          CASE SELF.Popup.Ask()
          OF 'filter'
            IF SELF.SetFilter() = BUTTON:Ok
              IF CLIP(SELF.Filter) <> ''
                SELF.FilterEnabled = 1
              ELSE
                SELF.FilterEnabled = 0
              END
              SELF.RefreshDirectory
            END
          OF 'filterenabled'
            SELF.FilterEnabled = CHOOSE(SELF.FilterEnabled=1,0,1)
            SELF.RefreshDirectory
          OF 'item1'
            SELF.SortMode = 1
          OF 'item2'
            SELF.SortMode = 2
          OF 'item3'
            SELF.SortMode = 3
          OF 'item4'
            SELF.SortMode = 4
          END
          SELF.SortDir
        END
      OF EVENT:NewSelection
        GET(SELF.SELFiles, CHOICE(SELF.FileList))
        IF LOC:ShowPictureFile <> CLIP(SELF.FindPath)&CLIP(SELF.SelFiles.FileName)
          LOC:ShowPictureFile = CLIP(SELF.FindPath)&CLIP(SELF.SelFiles.FileName)
          LOC:ShowPicture = TRUE
          LOC:ShowTime    = 20
        END
      END
    OF ?DrvCombo
      GET(SELF.Drivers, CHOICE(?DrvCombo))
      IF SELF.OldDrive <> SELF.Drivers.Disk
        SELF.FindPath = SELF.Drivers.Disk&'\'
        SELF.RefreshDirectory
        SELF.OldDrive = SELF.Drivers.Disk
      END
    END ! case field
!---------------------
    CASE EVENT()
    OF EVENT:Sized
      SELF.Resizer.Resize
      SELF.ResizeImages
    OF EVENT:Timer
      IF LOC:ShowPicture = TRUE
        GET(SELF.SELFiles, CHOICE(SELF.FileList))
        IF LOC:ShowPictureFile = CLIP(SELF.FindPath)&CLIP(SELF.SelFiles.FileName)
          LOC:ShowTime = LOC:ShowTime - Window{PROP:Timer}
          IF LOC:ShowTime < 0
            SELF.RefreshPicture
            LOC:ShowPicture = FALSE
          END
        ELSE
          LOC:ShowPicture = FALSE
        END
      END
    OF EVENT:CloseWindow
      SETPATH(SELF.OldPath)
    OF EVENT:OpenWindow
       !   PictureFile, StartPath
       !   
       !    
       SELF.FirstFill = FALSE
       !    
       LOC:PictureFile = SELF.NormalizeFileName(PictureFile)
       LOC:StartPath   = SELF.NormalizeFileName(StartPath)
       !  
       SELF.OldPath = LONGPATH()
       !   
       OldFile = PictureFile
       !   LOC:PictureFile    LOC:StartPath
       IF SELF.FindFile(LOC:PictureFile) = FALSE
         SELF.FindPath = SELF.NormDir(LOC:StartPath)
       !  LOC:PictureFile 
       ELSE
         !       
         SELF.FindFile = SELF.ExtractFile(LOC:PictureFile)
         !   
         SELF.FindPath = SELF.ExtractPath(LOC:PictureFile)
         !  ,   
         IF CLIP(SELF.FindPath) = ''
           SELF.FindPath = SELF.NormDir(LONGPATH())
         END
       END
       !   
       IF SELF.PathExists(SELF.FindPath) = FALSE
         !   
         IF SUB(SELF.FindPath, 2, 1) = ':'
           !   - 
           SELF.FindPath = CLIP(UPPER(SELF.ExtractDriver(SELF.FindPath))) & '\'
         !      
         ELSE
           !    C:\
           SELF.FindPath = 'C:\'
         END
         !  
         SELF.FindFile = ''
       END
       SELF.RefreshDrive                                         !
       SELF.RefreshDirectory
       SELF.FillStoredDir
    OF EVENT:PreAlertKey
      CASE KEYCODE()
      OF F5Key
        SELF.RefreshDirectory
      OF F4Key
        POST(EVENT:DroppingDown,?DrvCombo)
        SELECT(?DrvCombo)
      END
    END ! case event
!---------------------
  END
  SELF.LFormat = ?FileList{PROP:Format}
  SELF.SaveINI

  PUTINI('xpbWin', 'XPos',   Window{PROP:XPos}, SELF.INIFileName)
  PUTINI('xpbWin', 'YPos',   Window{PROP:YPos}, SELF.INIFileName)
  PUTINI('xpbWin', 'Width',   Window{PROP:Width}, SELF.INIFileName)
  PUTINI('xpbWin', 'Height',   Window{PROP:Height}, SELF.INIFileName)

  CLOSE(Window)
  IF Res:Mode = BUTTON:Ok
    IF INSTRING(UPPER(LONGPATH()), UPPER(SELF.CSTRING), 1, 1) = 1
      PictureFile = '.' & SUB(SELF.CSTRING, LEN(CLIP(LONGPATH())) + 1, 256)
    ELSE
      PictureFile = SELF.CSTRING
    END
  ELSE
    PictureFile = OldFile
  END
  IF ~OMITTED(5)
    ReturnState = Res:Mode
  END

  CLEAR(SELF.AllFiles)
  CLEAR(SELF.SelFiles)
  CLEAR(SELF.Drivers)
  CLEAR(SELF.StoredDir)
  FREE(SELF.AllFiles)
  FREE(SELF.SelFiles)
  FREE(SELF.Drivers)
  FREE(SELF.StoredDir)

  SELF.Resizer.Kill
!**********************************************************************************************************************
xPBrowseClass.SetFilter         PROCEDURE()!,BYTE,PRIVATE
LOC:Result                      BYTE(BUTTON:Cancel)
SetFilterWin WINDOW('Set filter'),AT(,,207,58),FONT('MS Sans Serif',8,,),CENTER,GRAY,DOUBLE
       PANEL,AT(1,1,205,36),USE(?Panel1),BEVEL(-1)
       PROMPT('Filter:'),AT(11,15,,10),USE(?Prompt)
       ENTRY(@s200),AT(47,15,150,10),USE(SELF.Filter)
       BUTTON('&OK'),AT(53,41,50,14),USE(?OKBtns),DEFAULT
       BUTTON('&Cancel'),AT(105,41,50,14),USE(?CancelBtns)
     END

  CODE
  OPEN(SetFilterWin)
  SELF.Trn.TranslateWindow(SetFilterWin)
  ACCEPT
    CASE ACCEPTED()
    OF ?OkBtns
      LOC:Result = BUTTON:Ok
      BREAK
    OF ?CancelBtns
      LOC:Result = BUTTON:Cancel
      BREAK
    END
  END
  CLOSE(SetFilterWin)
  RETURN LOC:Result
!**********************************************************************************************************************
xPBrowseClass.FillStoredDir     PROCEDURE
A                               BYTE
B                               CSTRING(256)
C                               CSTRING(256)
  CODE
  B = SUB(SELF.ExtractPath(SELF.FindPath), 4, 256)
  LOOP W# = 1 TO LEN(CLIP(B))
    IF SUB(B, W#, 1) = '\'
      IF CLIP(C) <> ''
        SELF.StoredDir.DirName = C
        ADD(SELF.StoredDir)
        IF ERRORCODE() THEN MESSAGE(ERROR()) END
        C = ''
      END
    ELSE
      C = C & SUB(B, W#, 1)
    END
  END
!**********************************************************************************************************************
xPBrowseClass.RestoreLevel      PROCEDURE
Temp:DirName                    STRING(255)
  CODE
  IF RECORDS(SELF.StoredDir)
    GET(SELF.StoredDir, RECORDS(SELF.StoredDir))
    IF ~ERRORCODE()
      Temp:DirName = SELF.StoredDir.DirName
      DELETE(SELF.StoredDir)
      IF ERRORCODE() THEN MESSAGE(ERROR()) END
      LOOP W# = 1 TO RECORDS(SELF.SELFiles)
        GET(SELF.SELFiles, W#)
        IF ERRORCODE() THEN MESSAGE(ERROR()) END
        IF CLIP(UPPER(Temp:DirName)) = CLIP(SELF.SELFiles.UpperFileName)
          SELECT(SELF.FileList, W#)
          RETURN
        END
      END
    END
  END
  SELECT(SELF.FileList, 1)
!**********************************************************************************************************************
xPBrowseClass.StoreLevel        PROCEDURE(STRING DirName)
  CODE
  SELF.StoredDir.DirName = DirName
  ADD(SELF.StoredDir)
  IF ERRORCODE() THEN MESSAGE(ERROR()) END
!**********************************************************************************************************************
xPBrowseClass.RefreshDirectory  PROCEDURE
SF                              LONG
LP                              LONG
Recs                            LONG
LOC:FileForCheck                STRING(255)
  CODE
  FREE(SELF.AllFiles)
  CLEAR(SELF.AllFiles)
  FREE(SELF.SelFiles)
  CLEAR(SELF.SelFiles)
  DIRECTORY(SELF.AllFiles, CLIP(SELF.FindPath) & '*.*', ff_:DIRECTORY + ff_:NORMAL)
  SORT(SELF.AllFiles, SELF.AllFiles.Name)
  SF = 1
  SELF.SelFiles.FileName = '..'
  SELF.SelFiles.Style1   = 1
  SELF.SelFiles.Style2   = 1
  SELF.SelFiles.Style3   = 1
  SELF.SelFiles.Style4   = 1
  SELF.SelFiles.Type     = 1
  SELF.SelFiles.Number   = SF
  SF += 1
  T# = INSTRING('\',SELF.FindPath,1,1)
  Y# = INSTRING('\',SELF.FindPath,1,T#+1)
  IF Y# <> 0
    ADD(SELF.SELFiles)
  END
  Recs = RECORDS(SELF.AllFiles)
  LOOP LP = 1 TO Recs
    GET(SELF.AllFiles, LP)
    IF SELF.AllFiles.ShortName[1] <> '.'

      IF BAND(SELF.AllFiles.Attrib, ff_:DIRECTORY)
        SELF.SelFiles.Type   = 2
        SELF.SelFiles.Style1 = 1
        SELF.SelFiles.Style2 = 1
        SELF.SelFiles.Style3 = 1
        SELF.SelFiles.Style4 = 1
      ELSE
        IF SELF.FilterEnabled AND NOT MATCH(UPPER(SELF.AllFiles.Name), UPPER(CLIP(SELF.Filter)), MATCH:Wild)
          CYCLE
        END
        SELF.SelFiles.Type = 3
        CASE UPPER(SELF.ExtractExt(SELF.AllFiles.Name))
        OF 'GIF'
          SELF.SelFiles.Style1 = 2
          SELF.SelFiles.Style2 = 2
          SELF.SelFiles.Style3 = 2
          SELF.SelFiles.Style4 = 2
        OF 'JPG'
        OROF 'JPEG'
          SELF.SelFiles.Style1 = 3
          SELF.SelFiles.Style2 = 3
          SELF.SelFiles.Style3 = 3
          SELF.SelFiles.Style4 = 3
        OF 'BMP'
          SELF.SelFiles.Style1 = 4
          SELF.SelFiles.Style2 = 4
          SELF.SelFiles.Style3 = 4
          SELF.SelFiles.Style4 = 4
        OF 'WMF'
          SELF.SelFiles.Style1 = 5
          SELF.SelFiles.Style2 = 5
          SELF.SelFiles.Style3 = 5
          SELF.SelFiles.Style4 = 5
        OF 'ICO'
          SELF.SelFiles.Style1 = 6
          SELF.SelFiles.Style2 = 6
          SELF.SelFiles.Style3 = 6
          SELF.SelFiles.Style4 = 6
        ELSE
          CYCLE
        END
      END

      SELF.SelFiles.Number = SF
      SELF.SelFiles.FileName = SELF.AllFiles.Name
      SELF.SelFiles.UpperFileName = UPPER(SELF.AllFiles.Name)
      SELF.SelFiles.FileSize = SELF.AllFiles.Size
      SELF.SelFiles.FileDate = SELF.AllFiles.Date
      SELF.SelFiles.FileTime = SELF.AllFiles.Time
      SELF.SelFiles.FileExt  = SELF.ExtractExt(SELF.AllFiles.Name)
      SF += 1
      ADD(SELF.SELFiles)
      CYCLE
    END
  END
  SELF.SortDir
  Recs = RECORDS(SELF.SELFiles)
  LOOP LP = 1 TO Recs
    GET(SELF.SELFiles, LP)
    SELF.SelFiles.Number = LP
    PUT(SELF.SELFiles)
  END
  IF SELF.FirstFill = FALSE
    SELF.SelFiles.FileName = CLIP(SELF.FindFile)
    GET(SELF.SELFiles, SELF.SelFiles.FileName)
    IF NOT ERRORCODE()
      SELECT(SELF.FileList, SELF.SelFiles.Number)
    END
  ELSE
    SELECT(SELF.FileList, 1)
  END
  GET(SELF.SELFiles, CHOICE(SELF.FileList))
  LOC:FileForCheck = CLIP(SELF.FindPath)&CLIP(SELF.SelFiles.FileName)
  IF SELF.SelFiles.Type = 3 AND SELF.FindFile(LOC:FileForCheck)
    SELF.CSTRING = CLIP(SELF.FindPath)&CLIP(SELF.SelFiles.FileName)
  ELSE
    SELF.CSTRING = SELF.ExtractPath(SELF.FindPath)
  END

  SELF.SetStyle

  SELF.FileList{PROPSTYLE:charset, 1}       = 204
  SELF.FileList{PROPSTYLE:charset, 2}       = 204
  SELF.FileList{PROPSTYLE:charset, 3}       = 204
  SELF.FileList{PROPSTYLE:charset, 4}       = 204
  SELF.FileList{PROPSTYLE:charset, 5}       = 204
  SELF.FileList{PROPSTYLE:charset, 6}       = 204
  DISPLAY(SELF.FileList)

  DISPLAY(SELF.CSTRING)
  SELF.FirstFill = TRUE
  SELF.RefreshPicture

!**********************************************************************************************************************
xPBrowseClass.SortDir           PROCEDURE()
  CODE
  CASE SELF.SortMode
  OF 1
    SORT(SELF.SELFiles,'+SEL:Type,+SEL:FileExt,+SEL:UpperFileName')
  OF 2
    SORT(SELF.SELFiles,'+SEL:Type,+SEL:UpperFileName')
  OF 3
    SORT(SELF.SELFiles,'+SEL:Type,+SEL:FileSize,+SEL:UpperFileName')
  OF 4
    SORT(SELF.SELFiles,'+SEL:Type,+SEL:FileDate,+SEL:FileTime,+SEL:UpperFileName')
  END
!**********************************************************************************************************************
xPBrowseClass.RefreshDrive      PROCEDURE()
LOC:DRV:Disk                    CSTRING(10)
  CODE
  FREE(SELF.Drivers)
  ! 
  FREE(SELF.StoredDir)
  Q# = GetLogicalDrives()
  I# = 65
  J# = 0
  Z# = 0
  LOOP WHILE Q#
   IF BAND( Q#, 1 )
    J#+=1
    SELF.Drivers.Disk = CHR(I#)&':'
    LOC:DRV:Disk = CLIP(SELF.Drivers.Disk) & '\'
    W# = GetDriveType(LOC:DRV:Disk)
    CASE W#
    OF DRIVE_REMOTE
      SELF.Drivers.DiskType = CLIP(SELF.Trn.TranslateString('Network'))
    OF DRIVE_REMOVABLE
      SELF.Drivers.DiskType = CLIP(SELF.Trn.TranslateString('Removable'))
    OF DRIVE_FIXED
      SELF.Drivers.DiskType = CLIP(SELF.Trn.TranslateString('Fixed'))
    OF DRIVE_CDROM
      SELF.Drivers.DiskType = CLIP(SELF.Trn.TranslateString('CD-ROM'))
    OF DRIVE_RAMDISK
      SELF.Drivers.DiskType = CLIP(SELF.Trn.TranslateString('Ram'))
    END
    ADD(SELF.Drivers)
    IF UPPER(SELF.Drivers.Disk) = UPPER(SELF.ExtractDriver(SELF.FindPath)) THEN Z#=J# END
   END
   Q# = BSHIFT(Q#,-1)
   I#+=1
  END
  IF (~SELF.PathExists(SELF.FindPath)) OR (LEN(CLIP(SELF.FindPath)) < 2)
    SELF.FindPath = 'C:\'
    J# = RECORDS(SELF.Drivers)
    LOOP Z# = 1 TO J#
      GET(SELF.Drivers, Z#)
      IF SELF.Drivers.Disk = 'C:' THEN BREAK END
    END
  END
  GET(SELF.Drivers, Z#)
  SELECT(SELF.DrvCombo, Z#)
  DISPLAY(SELF.DrvCombo)
  SELF.OldDrive = SELF.Drivers.Disk
!**********************************************************************************************************************
xPBrowseClass.RefreshPicture        PROCEDURE()
  CODE
  GET(SELF.SELFiles, CHOICE(SELF.FileList))
  IF SELF.SelFiles.Type = 3
    SELF.ResultString = CLIP(SELF.FindPath)&CLIP(SELF.SelFiles.FileName)
    SELF.CSTRING = SELF.ResultString
  ELSE
    SELF.CSTRING = SELF.ExtractPath(SELF.FindPath)
  END
  CASE UPPER(SELF.ExtractExt(SELF.SelFiles.FileName))
  OF 'GIF'
  OROF 'JPG'
  OROF 'JPEG'
  OROF 'BMP'
  OROF 'WMF'
  OROF 'ICO'
    SELF.ImageOne.ShowPicture(SELF.ResultString, SELF.PMode)
    ENABLE(SELF.OkBtn)
  ELSE
    SELF.ResultString = ''
    SELF.ImageOne.ShowPicture(SELF.ResultString, SELF.PMode)
    DISABLE(SELF.OkBtn)
  END
  DISPLAY
!**********************************************************************************************************************
xPBrowseClass.SetStyle              PROCEDURE()
  CODE
  SELF.FileList{PROPSTYLE:fontcolor, 1}     = COLOR:Black
  SELF.FileList{PROPSTYLE:fontcolor, 2}     = COLOR:Fuschia
  SELF.FileList{PROPSTYLE:fontcolor, 3}     = COLOR:Green
  SELF.FileList{PROPSTYLE:fontcolor, 4}     = COLOR:Red
  SELF.FileList{PROPSTYLE:fontcolor, 5}     = COLOR:Teal
  SELF.FileList{PROPSTYLE:fontcolor, 6}     = COLOR:Blue
!**********************************************************************************************************************
xPBrowseClass.ExtractDriver         PROCEDURE  (STRING INP:Path)
LOC:Path             CSTRING(256)
LOC:Dir              CSTRING(256)
LOC:Drive            CSTRING(256)
LOC:File             CSTRING(256)
LOC:Ext              CSTRING(256)
  CODE
 LOC:Path = INP:Path
 IF FnSplit(LOC:Path,LOC:Drive,LOC:Dir,LOC:File,LOC:Ext) END
 RETURN(CLIP(LOC:Drive))
!**********************************************************************************************************************
xPBrowseClass.PathExists           PROCEDURE  (STRING INP:Path)
LOC:PathOld          STRING(256)
  CODE
  LOC:PathOld = LONGPATH()
  SETPATH(INP:Path)
  IF ERRORCODE() = 03
    SETPATH(LOC:PathOld)
    RETURN FALSE
  ELSE
    SETPATH(LOC:PathOld)
  END
  RETURN TRUE
!**********************************************************************************************************************
xPBrowseClass.FindFile             PROCEDURE(STRING FileName)
FIQ                  QUEUE,PRE(F_IQ)
Name                   STRING(FILE:MAXFILENAME)
ShortName              STRING(13)
Date                   LONG
Time                   LONG
Size                   LONG
Attrib                 BYTE
                     END
  CODE
  DIRECTORY(FIQ, FileName, FF_:DIRECTORY)
  IF RECORDS(FIQ)
    RETURN TRUE
  END
  RETURN FALSE
!**********************************************************************************************************************
xPBrowseClass.ExtractPath          PROCEDURE  (STRING INP:Path)
LOC:Path             CSTRING(256)
LOC:Dir              CSTRING(256)
LOC:Drive            CSTRING(256)
LOC:File             CSTRING(256)
LOC:Ext              CSTRING(256)
  CODE
 LOC:Path = INP:Path
 IF FnSplit(LOC:Path,LOC:Drive,LOC:Dir,LOC:File,LOC:Ext).
 RETURN(SELF.NormDir(CLIP(LOC:Drive)&CLIP(LOC:Dir)))
!**********************************************************************************************************************
xPBrowseClass.ExtractFile          PROCEDURE  (STRING INP:Path)
LOC:Path             CSTRING(256)
LOC:Dir              CSTRING(256)
LOC:Drive            CSTRING(256)
LOC:File             CSTRING(256)
LOC:Ext              CSTRING(256)
  CODE
 LOC:Path = INP:Path
 IF FnSplit(LOC:Path,LOC:Drive,LOC:Dir,LOC:File,LOC:Ext).
 RETURN(CLIP(LOC:File)&CLIP(LOC:Ext))
!**********************************************************************************************************************
xPBrowseClass.ExtractExt           PROCEDURE  (STRING INP:Path)
LOC:Path             CSTRING(256)
LOC:Dir              CSTRING(256)
LOC:Drive            CSTRING(256)
LOC:File             CSTRING(256)
LOC:Ext              CSTRING(256)
  CODE
 LOC:Path = INP:Path
 IF FnSplit(LOC:Path,LOC:Drive,LOC:Dir,LOC:File,LOC:Ext).
 RETURN(CLIP(SUB(LOC:Ext,2,256)))
!**********************************************************************************************************************
xPBrowseClass.NormDir              PROCEDURE  (STRING INPath)
  CODE
 IF CLIP(InPath) = '' THEN RETURN '' END
 IF SUB(CLIP(InPath),-1,1) = '\'
   RETURN(InPath)
 ELSE
   RETURN(CLIP(InPath)&'\')
 END
!**********************************************************************************************************************
xPBrowseClass.LoadINI               PROCEDURE
  CODE
  SELF.SortMode      = GETINI('Setup', 'SortMode', SELF.SortMode, SELF.INIFileName)
  SELF.PMode         = GETINI('Setup', 'PictureMode', SELF.PMode, SELF.INIFileName)
  SELF.LFormat       = GETINI('Setup', 'LFormat', SELF.LFormat, SELF.INIFileName)
  SELF.OFormat       = GETINI('Setup', 'OFormat', SELF.OFormat, SELF.INIFileName)
!**********************************************************************************************************************
xPBrowseClass.SaveINI               PROCEDURE
  CODE
  PUTINI('Setup', 'SortMode',   SELF.SortMode, SELF.INIFileName)
  PUTINI('Setup', 'PictureMode', SELF.PMode, SELF.INIFileName)
  PUTINI('Setup', 'LFormat', SELF.LFormat, SELF.INIFileName)
  PUTINI('Setup', 'OFormat', SELF.OFormat, SELF.INIFileName)
!*************************************************************************************************************************
xPBrowseClass.SetCaption          PROCEDURE(STRING Normal)
  CODE
  IF CLIP(Normal) <> ''
    SELF.CaptionName = Normal
  END
!*************************************************************************************************************************
xPBrowseClass.NormalizeFileName   PROCEDURE(STRING FileName)
  CODE
  IF SUB(FileName,1,1) = '.'
    RETURN (SELF.NormDir(LONGPATH())&SUB(FileName,3,LEN(FileName)-2))
  END
  IF SUB(FileName,1,1) = '\'
    RETURN (SELF.NormDir(LONGPATH())&SUB(FileName,2,LEN(FileName)-1))
  END
  IF SUB(FileName,2,1) <> ':'
    RETURN (SELF.NormDir(LONGPATH())&CLIP(FileName))
  END
  RETURN (FileName)
!*************************************************************************************************************************
xPBrowseClass.ResizeImages        PROCEDURE
  CODE
  SELF.ImageOne.ResizePicture
!**********************************************************************************************************************!
!                                                                                                                      !
!                                                                                                                      !
!**********************************************************************************************************************!
xPViewClass.Construct                 PROCEDURE
  CODE
!**********************************************************************************************************************
xPViewClass.Destruct                  PROCEDURE
  CODE
  SELF.Kill
!**********************************************************************************************************************
xPViewClass.Init                      PROCEDURE(WINDOW ParWin, LONG ControlImage, LONG ControlPanel, BYTE BorderSize)
  CODE
  SELF.Window    &= ParWin
  SELF.Image      = ControlImage
  SELF.Panel      = ControlPanel
  SELF.BorderSize = BorderSize
  SELF.Mode       = MODE:A
!**********************************************************************************************************************
xPViewClass.ShowPicture               PROCEDURE(STRING FileName, <BYTE Mode>, <STRING FileName1>)
  CODE
  IF ~OMITTED(3)
    SELF.Mode = Mode
  END
  IF ~OMITTED(4)
    SELF.FileName = FileName1
  END
  SELF.Image{PROP:Hide} = TRUE
  SELF.Image{PROP:Text} = FileName
  IF (CLIP(FileName) <> '' AND SELF.FindFile(FileName)) OR SUB(FileName,1,1) = '~'
    SELF.PicExist = TRUE
  ELSE
    SELF.PicExist = FALSE
  END
  SELF.ResizePicture
!**********************************************************************************************************************
xPViewClass.ShowBlob                  PROCEDURE(*BLOB BlobContainer, <BYTE Mode>)
  CODE
  IF ~OMITTED(3)
    SELF.Mode = Mode
  END
  SELF.Image{PROP:Hide}      = TRUE
  SELF.Image{PROP:ImageBlob} = BlobContainer{PROP:Handle}
  IF BlobContainer{PROP:Size} <> 0
    SELF.PicExist = TRUE
  ELSE
    SELF.PicExist = FALSE
  END
  SELF.ResizePicture
!**********************************************************************************************************************
xPViewClass.ResizePicture             PROCEDURE(<BYTE Mode>, BYTE ForceShow=0)
PW                                    LONG
PH                                    LONG
IW                                    LONG
IH                                    LONG
  CODE
  IF ~OMITTED(2)
    SELF.Mode = Mode
  END
  SELF.Image{PROP:Hide} = TRUE
  SELF.Image{PROP:NoHeight} = TRUE
  SELF.Image{PROP:NoWidth} = TRUE

  PW = SELF.Panel{PROP:Width} - (SELF.BorderSize * 2)
  PH = SELF.Panel{PROP:Height} - (SELF.BorderSize * 2)
  IW = SELF.Image{PROP:Width}
  IH = SELF.Image{PROP:Height}

  CASE SELF.Mode
  OF MODE:A
    IF IW < PW AND IH < PH
      SELF.Image{PROP:Tiled} = FALSE
      SELF.Image{PROP:Centered} = TRUE
    ELSE
      SELF.Image{PROP:Tiled} = FALSE
      SELF.Image{PROP:Centered} = FALSE
      IF IW / IH > PW / PH
        SELF.Image{PROP:Height} = (IH * PW / IW)
        SELF.Image{PROP:Width} = PW
      ELSE
        SELF.Image{PROP:Width} = (IW * PH / IH)
        SELF.Image{PROP:Height} = PH
      END
    END

    IW = SELF.Image{PROP:Width}
    IH = SELF.Image{PROP:Height}

    SETPOSITION(SELF.Image, |
     ((PW - IW) / 2) + SELF.Panel{PROP:XPOS} + SELF.BorderSize, ((PH - IH) / 2) + SELF.Panel{PROP:YPOS} + SELF.BorderSize, IW, IH)
  OF MODE:S
    SETPOSITION(SELF.Image, SELF.Panel{PROP:XPOS} + SELF.BorderSize, SELF.Panel{PROP:YPOS} + SELF.BorderSize, SELF.Panel{PROP:Width} - (SELF.BorderSize * 2), SELF.Panel{PROP:Height} - (SELF.BorderSize * 2))
    SELF.Image{PROP:Tiled}    = FALSE
    SELF.Image{PROP:Stretch}  = FALSE
    SELF.Image{PROP:Centered} = TRUE
  OF MODE:T
    SETPOSITION(SELF.Image, SELF.Panel{PROP:XPOS} + SELF.BorderSize, SELF.Panel{PROP:YPOS} + SELF.BorderSize, SELF.Panel{PROP:Width} - (SELF.BorderSize * 2), SELF.Panel{PROP:Height} - (SELF.BorderSize * 2))
    SELF.Image{PROP:Centered} = FALSE
    SELF.Image{PROP:Stretch}  = FALSE
    SELF.Image{PROP:Tiled}    = TRUE
  END
  IF SELF.PicExist = TRUE OR ForceShow = TRUE
    SELF.Image{PROP:Hide} = FALSE
  END
!**********************************************************************************************************************
xPViewClass.Kill                      PROCEDURE
  CODE
!**********************************************************************************************************************
xPViewClass.SetMode                   PROCEDURE(BYTE MODE)
  CODE
  SELF.Mode = Mode
!**********************************************************************************************************************
xPViewClass.FindFile                  PROCEDURE(STRING FileName)
FIQ                  QUEUE,PRE(F_IQ)
Name                   STRING(FILE:MAXFILENAME)
ShortName              STRING(13)
Date                   LONG
Time                   LONG
Size                   LONG
Attrib                 BYTE
                     END
  CODE
  DIRECTORY(FIQ, FileName, FF_:DIRECTORY)
  IF RECORDS(FIQ)
    RETURN TRUE
  END
  RETURN FALSE
!**********************************************************************************************************************
xPViewClass.ExtractFile            PROCEDURE  (STRING INP:Path)
LOC:Path             CSTRING(256)
LOC:Dir              CSTRING(256)
LOC:Drive            CSTRING(256)
LOC:File             CSTRING(256)
LOC:Ext              CSTRING(256)
  CODE
 LOC:Path = INP:Path
 IF FnSplit(LOC:Path,LOC:Drive,LOC:Dir,LOC:File,LOC:Ext).
 RETURN(CLIP(LOC:File)&CLIP(LOC:Ext))
!**********************************************************************************************************************
xPViewClass.GetFileName            PROCEDURE()
  CODE
  RETURN SELF.ExtractFile(SELF.FileName)
!**********************************************************************************************************************
!
!
!**********************************************************************************************************************
xPViewReportClass.Init             PROCEDURE(Report ParReport, LONG ControlImage, LONG ControlPanel, BYTE BorderSize)
  CODE
  SELF.Report    &= ParReport
  SELF.Image      = ControlImage
  SELF.Panel      = ControlPanel
  SELF.BorderSize = BorderSize
  SELF.Mode       = MODE:A
!**********************************************************************************************************************
xPViewReportClass.ShowPicture      PROCEDURE(STRING FileName, <BYTE Mode>, <STRING FileName1>)
  CODE
  IF ~OMITTED(3)
    SELF.Mode = Mode
  END
  IF ~OMITTED(4)
    SELF.FileName = FileName1
  END
  SETTARGET(SELF.Report)
  SELF.Image{PROP:Hide} = TRUE
  SELF.Image{PROP:Text} = FileName
  SETTARGET()
  IF (CLIP(FileName) <> '' AND SELF.FindFile(FileName)) OR SUB(FileName,1,1) = '~'
    SELF.PicExist = TRUE
  ELSE
    SELF.PicExist = FALSE
  END
  SELF.ResizePicture
!**********************************************************************************************************************
xPViewReportClass.ShowBlob         PROCEDURE(*BLOB BlobContainer, <BYTE Mode>, BYTE ForceShow=0)
  CODE
  IF ~OMITTED(3)
    SELF.Mode = Mode
  END
  SETTARGET(SELF.Report)
  SELF.Image{PROP:Hide}      = TRUE
  SELF.Image{PROP:ImageBlob} = BlobContainer{PROP:Handle}
  SETTARGET()
  IF BlobContainer{PROP:Size} <> 0
    SELF.PicExist = TRUE
  ELSE
    SELF.PicExist = FALSE
  END
  SELF.ResizePicture(,ForceShow)
!**********************************************************************************************************************
xPViewReportClass.ResizePicture    PROCEDURE(<BYTE Mode>, BYTE ForceShow=0)
PW                                 LONG
PH                                 LONG
IW                                 LONG
IH                                 LONG
  CODE
  IF ~OMITTED(2)
    SELF.Mode = Mode
  END
  SETTARGET(SELF.Report)
  SELF.Image{PROP:Hide} = TRUE
  SELF.Image{PROP:NoHeight} = TRUE
  SELF.Image{PROP:NoWidth} = TRUE

  PW = SELF.Panel{PROP:Width} - (SELF.BorderSize * 2)
  PH = SELF.Panel{PROP:Height} - (SELF.BorderSize * 2)
  IW = SELF.Image{PROP:Width}
  IH = SELF.Image{PROP:Height}

  CASE SELF.Mode
  OF MODE:A
    IF IW < PW AND IH < PH
      SELF.Image{PROP:Tiled} = FALSE
      SELF.Image{PROP:Centered} = TRUE
    ELSE
      SELF.Image{PROP:Tiled} = FALSE
      SELF.Image{PROP:Centered} = FALSE
      IF IW / IH > PW / PH
        SELF.Image{PROP:Height} = (IH * PW / IW)
        SELF.Image{PROP:Width} = PW
      ELSE
        SELF.Image{PROP:Width} = (IW * PH / IH)
        SELF.Image{PROP:Height} = PH
      END
    END

    IW = SELF.Image{PROP:Width}
    IH = SELF.Image{PROP:Height}

    SELF.Image{PROP:XPos}   = ((PW - IW) / 2) + SELF.Panel{PROP:XPOS} + SELF.BorderSize
    SELF.Image{PROP:YPos}   = ((PH - IH) / 2) + SELF.Panel{PROP:YPOS} + SELF.BorderSize
    SELF.Image{PROP:Width}  = IW
    SELF.Image{PROP:Height} = IH
  OF MODE:S
    SELF.Image{PROP:XPos}   = SELF.Panel{PROP:XPOS} + SELF.BorderSize
    SELF.Image{PROP:YPos}   = SELF.Panel{PROP:YPOS} + SELF.BorderSize
    SELF.Image{PROP:Width}  = SELF.Panel{PROP:Width} - (SELF.BorderSize * 2)
    SELF.Image{PROP:Height} = SELF.Panel{PROP:Height} - (SELF.BorderSize * 2)

    SELF.Image{PROP:Tiled}    = FALSE
    SELF.Image{PROP:Stretch}  = FALSE
    SELF.Image{PROP:Centered} = TRUE
  OF MODE:T
    SELF.Image{PROP:XPos}   = SELF.Panel{PROP:XPOS} + SELF.BorderSize
    SELF.Image{PROP:YPos}   = SELF.Panel{PROP:YPOS} + SELF.BorderSize
    SELF.Image{PROP:Width}  = SELF.Panel{PROP:Width} - (SELF.BorderSize * 2)
    SELF.Image{PROP:Height} = SELF.Panel{PROP:Height} - (SELF.BorderSize * 2)

    SELF.Image{PROP:Centered} = FALSE
    SELF.Image{PROP:Stretch}  = FALSE
    SELF.Image{PROP:Tiled}    = TRUE
  END
  IF SELF.PicExist = TRUE OR ForceShow = TRUE
    SELF.Image{PROP:Hide} = FALSE
  END
  SETTARGET()
!**********************************************************************************************************************
